% jh.sty
%  Macros I often use.
\usepackage{mathtools,amssymb}

% ================== Some handy definitions =============

% functions
\newcommand{\fcn}[3]{\mbox{$#1\colon #2\to #3$}}
\newcommand{\map}[3]{\fcn{#1}{#2}{#3}}
\newcommand{\mapsunder}[1]{\stackrel{#1}{\longmapsto}} % for elets: d |-> c
\newcommand{\mapsvia}[1]{\xrightarrow{#1}} % for fcns: D -> C
% doesn't seem to be in mathtools: \newcommand{\mapsunder}[1]{\xrightmapsto{#1}}
\newcommand{\xmapsunder}[1]{\mapsunder{#1}}
\newcommand{\composed}[2]{\mathord{#1\mathbin{\circ} #2}}
% \newcommand{\identity}{\mbox{id}}
\DeclareMathOperator{\identity}{id}
\newcommand{\restrictionmap}[2]{{#1}\mathord\upharpoonright_{#2}}
\DeclareMathOperator{\domain}{dom}
\DeclareMathOperator{\codomain}{cod}
\DeclareMathOperator{\range}{ran}

\DeclareMathOperator{\rem}{rem}  % remainder

% \computablefunction Treat like an operator but in tt style
\newcommand{\computablefunction}[1]{\operatorname{\texttt{#1}}}

% cases case: for \begin{cases} x &\case{if $x<0$} \\ ..}
\newcommand{\case}[1]{\text{-- #1}}

% sets
\newcommand{\N}{\mathbb{N}}
\newcommand{\Z}{\mathbb{Z}}
\newcommand{\Q}{\mathbb{Q}}
\newcommand{\R}{\mathbb{R}}
\newcommand{\B}{\mathbb{B}}  % booleans
  \newcommand{\true}{\ensuremath{T}}
  \newcommand{\false}{\ensuremath{F}}
\ifdefined\C\renewcommand{\C}{\mathbb{C}}\else\newcommand{\C}{\mathbb{C}}\fi
% emptyset
\ifdefined\emptyset %
  \renewcommand{\emptyset}{\varnothing}
\else
  \renewcommand{\emptyset}{\varnothing}
\fi
% sets
% \newcommand{\set}[1]{\{ #1 \}}
% setbuilder notation see http://tex.stackexchange.com/questions/5502/how-to-get-a-mid-binary-relation-that-grows
\newcommand{\setspacing}{0.1em}  % space between opening bbrace and set elet, and closing brace and set elet.  Note: \,=\thinspace=0.16667em
\newcommand{\set}[1]{\mbox{$\{\hspace{\setspacing}#1\hspace{\setspacing}\}$}} 
% \newcommand{\relmiddle}[1]{\mathrel{}\middle#1\mathrel{}}
% \newcommand{\suchthat}{\relmiddle|}
\newcommand{\suchthat}{\bigm|}
\newcommand{\setbuilder}[2]{\{#1 \suchthat #2\}}
\newcommand{\union}{\cup}
\newcommand{\intersection}{\cap}
% \newcommand{\setcomp}[1]{{#1}^\complement} % http://tex.stackexchange.com/questions/15984/what-symbol-should-one-use-for-a-set-complement
% Like this but it causes "too many math alphabets" \newcommand{\setcomp}[1]{{#1}^\mathsf{c}}
\newcommand{\setcomp}[1]{{#1}^{\scriptstyle\textsf{c}}}  
% \newcommand{\setcomp}[1]{\overline{#1}}
% \newcommand{\charfcn}[1]{\mathbf{\chi}_{#1}} 

%% \usepackage{bbm}
%% \newcommand{\charfcn}[1]{\mathbbm{1}_{#1}} % characteristic function

% for absolute value or cardinality http://tex.stackexchange.com/a/43009/339
\DeclarePairedDelimiter\sizeof{\lvert}{\rvert}%
\DeclarePairedDelimiter\norm{\lVert}{\rVert}%

\newcommand{\sequence}[1]{ \langle#1\rangle }  
\newcommand{\seq}[1]{\sequence{#1}}

% dots used in an interval, perhaps equal to or in place of \ldots
% see http://tex.stackexchange.com/a/75300/339
\newcommand{\idots}{\mathinner{{\ldotp}{\ldotp}}} 
\renewcommand*{\mathellipsis}{%
  \mathinner{{\ldotp}{\ldotp}{\ldotp}}%
}
% intervals
\newcommand{\jh@int}[4]{#1#3\idots #4#2}
\newcommand{\closed}[2]{\jh@int{[}{]}{#1}{#2}}
\newcommand{\leftclosed}[2]{\jh@int{[}{)}{#1}{#2}}
\newcommand{\rightclosed}[2]{\jh@int{(}{]}{#1}{#2}}
\let\rightopen\leftclosed %
\let\leftopen\rightclosed %
\newcommand{\open}[2]{\jh@int{(}{)}{#1}{#2}}

\newcommand{\divides}{\mid}
\newcommand{\ndivides}{\nmid}

% for fractions, in particular \sfrac{num}{denom}
% \usepackage{xfrac}

% In these fonts the root with an optional arg looks funny
\let\oldsqrt=\sqrt
\renewcommand{\sqrt}[2][]{%
  \oldsqrt[\raisebox{1pt}{\scriptsize$#1$\,}]{#2}}

% power set
\usepackage{mathrsfs}
\newcommand{\powerset}{\mathscr{P}}

% equivalence class
\usepackage{stmaryrd}
\DeclarePairedDelimiter\eqclass{\llbracket}{\rrbracket}
% \newcommand{\eqclass}[1]{\llbracket #1 \rrbracket}

% floor, ceiling
\DeclarePairedDelimiter\ceiling{\lceil}{\rceil}
\DeclarePairedDelimiter\floor{\lfloor}{\rfloor}
% \newcommand{\floor}[1]{\lfloor #1 \rfloor}
% \newcommand{\ceiling}[1]{\lceil #1 \rceil}
\renewcommand{\div}{\operatorname{div}}

% Strings
\newcommand{\strings}{\mathcal{S}}
\DeclareMathOperator*{\lh}{lh}
\providecommand{\str}[1]{\texttt{#1}}
\newcommand{\re}[1]{\str{#1}}
\newcommand{\emptystring}{\ensuremath{\varepsilon}}
\newcommand{\kleenestar}[1]{\ensuremath{{{#1}^{*}}}} % Kleene star

% concat: in math mode $a\concat b$; http://tex.stackexchange.com/a/203415/339
\def\concat{%
  \mathbin{\mathchoice%
    {\!\raise.75ex\hbox{$\smallfrown$\!}}% \displaystyle
    {\!\raise.75ex\hbox{$\smallfrown$}\!}% \textstyle
    {\!\raise.55ex\hbox{$\scriptstyle\smallfrown$}\!}% \scriptstyle
    {\!\raise.45ex\hbox{{$\scriptscriptstyle\smallfrown$}}\!}% \scriptscriptstyle
  }%
}%
% length of a string
\renewcommand{\lh}[1]{\ensuremath{|#1|}}
% reverse of a string
\newcommand{\reversal}[1]{{{#1}^{{\mskip 1mu}\textsf{R}}}}

% Big-Oh
\DeclareMathOperator*{\bigOh}{\mathcal{O}}
\DeclareMathOperator*{\bigTheta}{\Theta}

% general symbol for equiv class
\newcommand{\eclass}{\mathcal{E}}
% general symbol for part of a partition
\newcommand{\epart}{P}


% Possible other marks, look too dark and hand-written looks goofy
% \usepackage{pifont}% http://ctan.org/pkg/pifont
% \newcommand{\cmark}{\ding{51}}%
% \newcommand{\xmark}{\ding{56}}%
\newcommand{\ck}{\checkmark}



% ==================== ellipses and ldots ==============
% Make ellipsis space out properly before a period
% Use \dots command.
\usepackage[xspace]{ellipsis}
% Get inter-sentence spacing, when sentence ends in ldots
%  Use as either "$1, 2, 3, \ldots$\sentencespace" or 
% "Washington, Adams, \dots\sentencespace" 
\newcommand{\sentencespace}{\spacefactor=3000{} }


% Scientific notation
\newcommand{\scinot}[2]{#1\times 10^{#2}}


% ---------------------------------
% Vertically center graphics
% ex: \vcenteredhbox{\usegraphics{mygraph.png}}
% From http://tex.stackexchange.com/questions/7219/how-to-vertically-center-two-images
\newcommand*{\vcenteredhbox}[1]{\begingroup
\setbox0=\hbox{#1}\parbox{\wd0}{\box0}\endgroup}



% Tables
% Border text, column heads, etc.
% \newcommand{\tabulartext}[1]{{\textsc{\MakeLowercase{#1}}}}
\newcommand{\tabulartext}[1]{{\textit{#1}}}



% Vectors
\usepackage[f]{esvect}  % extensible vectors
\renewcommand{\vec}[1]{\vv{#1}}

